From 97c72100391fdc26bc872e55c68b62fb6ec8e039 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 23 2020 03:31:49 +0000
Subject: [PATCH 37/2232] Add test suite beyond the existing demo


---

diff --git a/Cargo.toml b/Cargo.toml
index b120173..fdfadc8 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -29,8 +29,9 @@ thiserror = "1.0"
 cc = "1.0.49"
 
 [dev-dependencies]
+cxx-test-suite = { version = "0", path = "tests/ffi" }
 rustversion = "1.0"
-trybuild = "1.0"
+trybuild = "1.0.21"
 
 [workspace]
-members = ["cmd", "demo-rs", "macro"]
+members = ["cmd", "demo-rs", "macro", "tests/ffi"]
diff --git a/tests/ffi/Cargo.toml b/tests/ffi/Cargo.toml
new file mode 100644
index 0000000..c84df61
--- /dev/null
+++ b/tests/ffi/Cargo.toml
@@ -0,0 +1,14 @@
+[package]
+name = "cxx-test-suite"
+version = "0.0.0"
+edition = "2018"
+publish = false
+
+[lib]
+path = "lib.rs"
+
+[dependencies]
+cxx = { path = "../.." }
+
+[build-dependencies]
+cxx = { path = "../.." }
diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
new file mode 100644
index 0000000..5c1bec3
--- /dev/null
+++ b/tests/ffi/build.rs
@@ -0,0 +1,11 @@
+fn main() {
+    if cfg!(trybuild) {
+        return;
+    }
+
+    cxx::Build::new()
+        .bridge("lib.rs")
+        .file("tests.cc")
+        .flag("-std=c++11")
+        .compile("cxx-test-suite");
+}
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
new file mode 100644
index 0000000..3ae732a
--- /dev/null
+++ b/tests/ffi/lib.rs
@@ -0,0 +1,6 @@
+#[cxx::bridge(namespace = tests)]
+pub mod ffi {
+    extern "C" {
+        include!("tests/ffi/tests.h");
+    }
+}
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
new file mode 100644
index 0000000..6996d77
--- /dev/null
+++ b/tests/ffi/tests.cc
@@ -0,0 +1,6 @@
+#include "tests/ffi/lib.rs"
+#include "tests/ffi/tests.h"
+
+namespace tests {
+
+} // namespace tests
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
new file mode 100644
index 0000000..61f11d5
--- /dev/null
+++ b/tests/ffi/tests.h
@@ -0,0 +1,6 @@
+#pragma once
+#include "include/cxxbridge.h"
+
+namespace tests {
+
+} // namespace tests

